<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Cch extends Controller_Template {


	public function before()
	{
	
		parent::before();
		$this->skud=Kohana::$config->load('config')->skud_wsdl;
	 	$this->accesspoint=Kohana::$config->load('config')->accesspoint_wsdl;
	}	
		
		
	public $template = 'template';
	
	
	
	public function action_err()
	{
		echo Debug::vars('34', 'err', $this->request->param('id')); exit;
		$content=View::factory('error_page');
	$this->template->content = $content;
	}
	
	
	public function action_index()
	{
		$version=Model::Factory('cch')->getSOAPVersion();// версия SOAP-сервера
		$list_action=Model::Factory('cch')->getActionList();// список мероприятий
		$content = View::factory('dashboard', array(
			'list' => $list_action['action'],
			'version'=>$version,
			'listPlaceName'=>$list_action['listPlaceName'],
			));
        $this->template->content = $content;
        //echo View::factory('profiler/stats');
	}
	
	public function action_doors()
	{
		$content='Page with doors';
		$list_doors=Model::Factory('cch')->getDoorsList();// список точек прохода
		$content=View::factory('doors', array(
			'doors'=>$list_doors,
			));
		$this->template->content = $content;
	}
	
	public function action_addaction()// добавление нового мероприятия. Закладка сделана с целью знакомства с билетной системой.
	{
		$content=View::factory('addaction', array(
		'title'=>__('action_edition'),
		'data'=>array(),
		));
		$this->template->content = $content;
	}
	
	public function action_insertAction()// вставка нового мероприятия.
	{
		$data=array('TimeStart'=>Arr::get($_GET, 'actionTimeStart'),
			'TimeEnd'=>Arr::get($_GET, 'actionTimeEnd'),
			'Attributes'=>array(),
			'ID'=>Arr::get($_GET, 'ID', 345),
			'Name'=>Arr::get($_GET, 'actionName', 'test22'),
			'Comment'=>Arr::get($_GET, 'actionComment', 'test comment')
			);
		$a=Model::Factory('cch')->insertAction($data);// вставка мероприятия
		if($a->Success){//проверка результата вставки. Если успешно - вывод сообщения ОК, если неуспешно - предложить отредактировать данные
			$content=View::factory('addaction_result', array(
			'mess' => $a,
			'111action_data'=>$data,
			));
		} else {
			$content=View::factory('addaction', array(
			'title'=>__('action_edition'),
			'data'=>$data,
			'mess'=>$a,
			));
		}
		$this->template->content = $content;
	}
	
	public function action_actionInfo()// вывод информации по указанному мероприятию
	{
		$actionID=$this->request->param('id');
		$actionInfo=Model::Factory('cch')->getActionInfoByID($actionID);// информация по мероприятию
		$actionPlaceList=Model::Factory('cch')->ActionPlaceGetList($actionID);// список площадок, на которых проводится мероприятие
		$listPlaceName=Model::Factory('cch')->listPlaceName();// список всех площадок
		$listPlaceStat=Model::Factory('cch')->GetCurrentActionStats($actionPlaceList, $actionID);// список всех площадок с данными о проходах
		$listDoor=Model::Factory('cch')->listDoor();// список дверей, приписанных к площадкам
        $getFailesPassList=Model::Factory('cch')->GetFailesPassList($actionID);// список отказов в проходе
		$content=View::factory('actioninfo', array(
			'data'=>$actionInfo,
			'actionPlaceList'=>$actionPlaceList,
			'listPlaceName'=>$listPlaceName,
			'listDoor'=>$listDoor,
			'listPlaceStat'=>$listPlaceStat,
            'getFailesPassList'=>$getFailesPassList,
			));
		$this->template->content = $content;
	}
	
	public function action_KeysGetByAction()
	{
		$actionID=$this->request->param('id');
		$KeysGetByAction = Model::Factory('cch')->KeysGetByAction($actionID);
		$actionInfo=Model::Factory('cch')->getActionInfoByID($actionID);
		$content=View::factory('KeysGetByAction', array(
			'KeysGetByAction'=>$KeysGetByAction,
			'actionID'=>$actionID,
			'actionInfo'=>$actionInfo,
			
			));
		$this->template->content = $content;
	}
	
	public function action_checktiket()// программа проверки билетов
	{
		$checktiket=$this->request->param('id');
		$content=View::factory('checktiket', array(
			'checktiket'=>$checktiket,
			));
		$this->template->content = $content;
	}
	
	public function action_GetKeyProperties()// программа проверки билетов
	{
		$ticketvalue=Arr::get($_GET, 'ticketvalue');
		$GetKeyProperties = Model::Factory('cch')->GetKeyProperties($ticketvalue);
		$getDoorsList = Model::Factory('cch')->getDoorsList2();
		if(isset($GetKeyProperties->Data->KeyByActionProps ))
		{ 
		$content=View::factory('GetKeyProperties', array(
			'GetKeyProperties'=>$GetKeyProperties,
			'getDoorsList'=>$getDoorsList,
			));
			
		} else {
			$content=View::factory('checktiket', array(
			'checktiket'=>$ticketvalue,
			'error_find'=>TRUE,
			));
		}
		$this->template->content = $content;
	}
	
	public function action_emulator()// набор приложений для эмуляции билетной системы
	{
			$content=View::factory('emulator', array(
			'result'=>'А пока ничего и не делали...',
		));
		$this->template->content = $content;
	}
	
	public function action_InsertkeyToAction()//вставка билета в указанное мероприятие
	{
		//echo Debug::vars('155', $_GET, '-7-', Arr::get($_GET, 'key')); exit;
		$key=Arr::get($_GET, 'key', '');
		$resultKeyInsert = Model::Factory('cch')->KeysAdd($key);
		$content=View::factory('emulator', array(
			'result'=>$resultKeyInsert,
		));
		$this->template->content = $content;
		
	}
	
	public function action_RegisterPass()//
	{
	//echo Debug::vars('168', $_GET); exit;
	$key=Arr::get($_GET, 'ticketvalue');
		$resultKeyInsert=Model::Factory('cch')->RegisterPass($key);
		$content=View::factory('emulator', array(
			'result'=>$resultKeyInsert,
		));
	$this->template->content = $content;
	}
	
	public function action_GetFailesPassList()//
	{
        //echo Debug::vars('179', $_GET); exit;
        $key=Arr::get($_GET, 'ActionID');
        $mess=Kohana::$config->load('config')->reason;
            $alarmEvent=Model::Factory('cch')->GetFailesPassList($key);
            $content=View::factory('emulator', array(
                'result'=>$alarmEvent,
                'alarmEvent'=>$alarmEvent,
                'mess'=>$mess,
            ));
        $this->template->content = $content;
	}
	
	
} // End cch
